package Tool;

use strict;

%input::month_numbers = (	'Jan'	=>	1,
				'Feb'	=>	2,
				'Mar'	=>	3,
				'Apr'	=>	4,
				'May'	=>	5,
				'Jun'	=>	6,
				'Jul'	=>	7,
				'Aug'	=>	8,
				'Sep'	=>	9,
				'Oct'	=>	10,
				'Nov'	=>	11,
				'Dec'	=>	12	);

#$input::extra = $::extra;

sub detect_referer
{
	my $referer = shift;
	$referer =~ s/\?.*//;
	foreach (keys %{$::config->{'local'}})
	{
		if ($referer =~ /$_/i)
		{
			$referer = 'localhost';
		}
	}
	$referer =~ s/^.+?:\/\/(?:www\.)?//i;
	$referer =~ s/\/$//;
	if ($referer =~ /^(.+?)(?::\d+)?\/.*$/ and $::config->{'referer'}{'host_only'})
	{
		$referer = $1;
	}
	return $referer;
}

sub detect_browser
{
	my $browser = shift;
	my $name = 'unknown';
	if ($browser =~ /MSIE/i) { $name = 'MSIE'; }
	elsif ($browser =~ /Lynx/i) { $name = 'Lynx'; }
	elsif ($browser =~ /Links/i) { $name = 'Links'; }
	elsif ($browser =~ /Opera/i) { $name = 'Opera'; }
	elsif ($browser =~ /WebTV/i) { $name = 'WebTV'; }
	elsif ($browser =~ /Konqueror/i) { $name = 'Konqueror'; }
	elsif ($browser =~ /curl/i) { $name = 'curl'; }
	elsif ($browser =~ /wget/i) { $name = 'wget'; }
	elsif ($browser =~ /GetRight|GoZilla/i) { $name = 'Download Manager'; }
	elsif ($browser =~ /bot|Google|Slurp|Scooter|Spider|Infoseek|Crawler|Mercator|FireBall|av\.com/i) { $name = 'Search Engines'; }
	elsif ($browser =~ /Mozilla.+compatible/i) { $name = 'Mozilla Compatible'; }
	elsif ($browser =~ /Nav|Gold|Mozilla|Netscape/i) { $name = 'Netscape'; }
	return $name;
}

sub detect_os
{
	my $os = $_[0];
	my $name = 'unknown';
	if ($os =~ /Linux|X11|KDE|Genome|Gnome/i) { $name = 'Linux'; }
	elsif ($os =~ /Win.*95/i) { $name = 'Windows 95'; }
	elsif ($os =~ /Win.*98/i) { $name = 'Windows 98'; }
	elsif ($os =~ /Win.*Me/i) { $name = 'Windows ME'; }
	elsif ($os =~ /Win.*NT/i) { $name = 'Windows NT'; }
	elsif ($os =~ /Win.*(2000|2k)/i) { $name = 'Windows 2000'; }
	elsif ($os =~ /Mac|PPC/i) { $name = 'MacOS'; }
	elsif ($os =~ /BSD/i) { $name = 'BSD'; }
	elsif ($os =~ /Sun/i) { $name = 'SunOS'; }
	elsif ($os =~ /IRIX/i) { $name = 'IRIX'; }
	elsif ($os =~ /BeOS/i) { $name = 'BeOS'; }
	elsif ($os =~ /OS.*2/i) { $name = 'OS/2'; }
	elsif ($os =~ /AIX/i) { $name = 'AIX'; }
	elsif ($os =~ /ix/i) { $name = 'some UNIX'; }
	elsif ($os =~ /Win/i) { $name = 'some Windows'; }
	return $name;
}

1;
