package input;

use strict;

use vars qw( %extra );

print "Using squid acces.log format <parser/squid.pm>\n" if $main::debug;

$extra{'total'} = 0;
$extra{'days'} = {};

sub parse
{
	my $line = shift or return undef;
	if ($line =~ /^(\S+)\s+(\d+)\s(\S+)\s(.+?)\/(\d+)\s(\d+)\s(\S+)\s(\S+)\s(\S+)\s(.+?)\/(\S+)\s(.*)$/)
	{
		my ($epoch, $duration, $client, $result_code, $http_code, $size, $method, $url, $ident, $hierarchy_code, $origin_host, $mime) = ($1, $2, $3, $4, $5, $6, $7, $8, $9, $10, $11, $12);

		return undef if $url eq '*';

		my ($sec, $min, $hour, $day, $month, $year) = (localtime ($epoch))[0..5];
		++$month; $year += 1900;
		my $date = sprintf ("%04d-%02d-%02d", $year, $month, $day);

		++$extra{'total'};
		if (!defined $extra{'days'}->{$date}) { $extra{'days'}->{$date} = 1; }

		my ($protocol, $server, $path);
		if ($url =~ /^(.+?)\:\/\/(.+?)(?:\:\d+)?(\/.+?)\??$/)
		{
			($protocol, $server, $path) = ($1, $2, $3);
		}
		else
		{
#			($protocol, $server, $path) = ('ERROR', 'ERROR', 'ERROR');
			return undef;
		}

		if ($server =~ /\.[a-z]{2,3}$/ and $::config->{'referer'}{'host_only'})
		{
			$server =~ s/^.+\.(.+?\..+?)$/$1/;
		}
		elsif ($server =~ /^(\d{1,3}\.\d{1,3}\.\d{1,3}\.)\d{1,3}$/ and $::config->{'referer'}{'host_only'})
		{
#			$server = $1;
			$server = 'UNRESOLVED';
		}
		my %combined = (
					'Client'	=>	$client,
					'ResultCodes'	=>	uc ($result_code),
					'HTTPStatus'	=>	$http_code,
					'Method'	=>	$method,
					'MIME'		=>	$mime,
					'Bytes'		=>	$size,
					'Server'	=>	$server,
					'Protocol'	=>	uc ($protocol),
					'HierarchyCodes'=>	uc ($hierarchy_code),
					'Date'		=>	$date,
					'Hour'		=>	$hour
										);
		data::save (\%combined);
		return 1;
	}
	return undef;
}

sub extra
{
	my ($average, $days) = (0, 0);
	$days = scalar keys %{$extra{'days'}};
	$average = int (($extra{'total'} * 10) / $days) / 10;
	$::extra->{'Total requests'} = $extra{'total'};
	$::extra->{'Averange requests per day'} = $average;
	$::extra->{'Reporting period'} = "$days days";
}

1;
